WndProc PROTO STDCALL :DWORD, :DWORD, :DWORD, :DWORD

.code
;===============================================================================
; WndProc
;===============================================================================
WndProc proc uses ebx hWnd:HWND, uMsg:UINT, wParam:WPARAM, lParam:LPARAM
LOCAL TempRect:RECT
LOCAL ProgRect:RECT
	mov eax, uMsg
;-------------------------------------------------------------------------------
; WM_CREATE
;-------------------------------------------------------------------------------
.IF eax==WM_CREATE
		
		; --- create main regkeys ---
		invoke	CreateRegKeys
		

    	; --- get last project ---
    	invoke	GetLastUsedProject
    	mov		fCurProject, al	;success flag
		; --- init main popup menu ---
		invoke	InitPopupMenus, hWnd
		
		.IF		fCurProject
    		invoke	lstrcpy, ADDR CurProject, ADDR LastProject
    		invoke	SetCurrentProject
    	.ENDIF
    	
		; --- set app bar ---
		invoke	NewAppBar, hWnd, WM_APPBARMSG

    	invoke	CreateRebar, hWnd
    	invoke	GetClientRect, hRebar, ADDR TempRect
    	
		; --- set app bar size ---
		mov		ProgRect.left, 		0
		invoke	GetSystemMetrics, SM_CXSCREEN
		;dec		eax
		mov		ProgRect.right, 	eax
		invoke	GetSystemMetrics, SM_CYSCREEN
		;dec		eax
		mov		ProgRect.bottom, 	eax
		mov		ProgRect.top, 		0
		invoke	SuggestScreenRect, hWnd, ADDR ProgRect, ABE_RIGHT
		invoke	GetSystemMetrics, SM_CXDLGFRAME 
		mov		ecx, eax
		shl		ecx, 1
		add		ecx, 2
		mov		eax, ProgRect.right
		sub		eax, TempRect.right
		add		eax, TempRect.left		
		sub		eax, ecx
		mov		ProgRect.left, eax
		invoke	SetAppBarPos, hWnd, ADDR ProgRect, ABE_RIGHT
    	mov		ecx, ProgRect.right
    	sub		ecx, ProgRect.left
    	mov		edx, ProgRect.bottom
    	sub		edx, ProgRect.top
    
    	invoke	MoveWindow, hWnd, ProgRect.left, ProgRect.top, ecx, edx, TRUE
    	


    		mov		ecx, TempRect.right
    		sub		ecx, TempRect.left
    		mov		eax, 30
   			sub		eax, ecx
    		shr		eax, 2
    	 	invoke	MoveWindow, hRebar, eax,30,ecx,300, 1
;-------------------------------------------------------------------------------
; WM_COMMAND
;-------------------------------------------------------------------------------
    .ELSEIF	eax==WM_COMMAND
    	mov		eax, wParam
    	shr		eax, 16
    	.IF		eax==NULL
    		mov		eax, wParam
    		and		eax, 0ffffh
    		invoke	ProcessMenu, hWnd, eax
    		mov		eax, wParam
    		and		eax, 0ffffh
	   		invoke	ProcessButton, hWnd, eax
    	.ENDIF
    	
;-------------------------------------------------------------------------------
; WM_APPBARMSG
;-------------------------------------------------------------------------------
    .ELSEIF eax==WM_APPBARMSG
    	mov		eax, wParam
    	.IF		eax==ABN_POSCHANGED
    		    	invoke	GetClientRect, hRebar, ADDR TempRect
    			mov		ProgRect.left, 		0
				invoke	GetSystemMetrics, SM_CXSCREEN
				;dec		eax
				mov		ProgRect.right, 	eax
				invoke	GetSystemMetrics, SM_CYSCREEN
				;dec		eax
				mov		ProgRect.bottom, 	eax
				mov		ProgRect.top, 		0
				invoke	SuggestScreenRect, hWnd, ADDR ProgRect, ABE_RIGHT
				invoke	GetSystemMetrics, SM_CXDLGFRAME 
				mov		ecx, eax
				shl		ecx, 1
					
				mov		eax, ProgRect.right
				sub		eax, TempRect.right
				add		eax, TempRect.left		
				sub		eax, ecx
				
				;size = 30 -  2x border - rebar size
				
				mov		ProgRect.left, eax
				invoke	SetAppBarPos, hWnd, ADDR ProgRect, ABE_RIGHT
		    	mov		ecx, ProgRect.right
		    	sub		ecx, ProgRect.left
		    	mov		edx, ProgRect.bottom
		    	sub		edx, ProgRect.top

		    	invoke	MoveWindow, hWnd, ProgRect.left, ProgRect.top, ecx, edx, TRUE
    	.ENDIF
    		mov		ecx, TempRect.right
    		sub		ecx, TempRect.left
    		mov		eax, 30
   			sub		eax, ecx
    		shr		eax, 2
    	 	invoke	MoveWindow, hRebar, eax,30,ecx,300, 1
	.ELSEIF eax==WM_DESTROY
		invoke	SetLastProject
		invoke	DeletePopupMenus
		invoke	CloseRegKeys
		invoke	KillAppBar, hWnd
		invoke 	PostQuitMessage,NULL
;-------------------------------------------------------------------------------
; WM_ACTIVATE
;-------------------------------------------------------------------------------
	.ELSEIF eax==WM_ACTIVATE
		invoke	SendAppBarActive, hWnd
;-------------------------------------------------------------------------------
; WM_WINDOWPOSCHANGED
;-------------------------------------------------------------------------------
	.ELSEIF eax==WM_WINDOWPOSCHANGED
		invoke	SendAppBarWinPosChange, hWnd
;-------------------------------------------------------------------------------
; Default window proc
;-------------------------------------------------------------------------------
	.ELSE
		invoke DefWindowProc,hWnd,uMsg,wParam,lParam		
		ret
	.ENDIF
@wp_end:
	ret
WndProc endp